import type { AxiosResponse } from 'axios'
import type { RequestInstanceState } from './type'
import { BACKEND_ERROR_CODE, createFlatRequest, createRequest } from '@sa/axios'
import { $t } from '@/locales'
import { useAuthStore } from '@/store/modules/auth'
import { getServiceBaseURL } from '@/utils/service'
import { localStg } from '@/utils/storage'
import { getAuthorization, handleExpiredRequest, showErrorMsg } from './shared'

const isHttpProxy = import.meta.env.DEV && import.meta.env.VITE_HTTP_PROXY === 'Y'
const { baseURL, otherBaseURL } = getServiceBaseURL(import.meta.env, isHttpProxy)

/**
 * 基础请求
 */
export const request = createFlatRequest(
  {
    baseURL,
    headers: {
      'apifoxToken': 'XL299LiMEDZ0H5h3A29PxwQXdMJqWyY2', // 用于 apifox 调试
      'Custom-Platform': 'pc',
    },
  },
  {
    defaultState: {
      errMsgStack: [], // 错误信息栈
      refreshTokenPromise: null, // 刷新token Promise
    } as RequestInstanceState,
    // 响应数据转换
    transform(response: AxiosResponse<App.Service.Response<any>>) {
      return response.data.data
    },
    // 请求配置转换
    async onRequest(config) {
      const Authorization = getAuthorization()
      Object.assign(config.headers, { Authorization })

      return config
    },
    // 响应状态判断
    isBackendSuccess(response) {
      // 当后端响应状态码为 "200"（默认值）时，表示请求成功
      // 如果你想自行更改此逻辑，可以在 .env 文件中修改 VITE_SERVICE_SUCCESS_CODE
      return String(response.data.code) === import.meta.env.VITE_SERVICE_SUCCESS_CODE
    },
    // 响应错误处理
    async onBackendFail(response, instance) {
      const authStore = useAuthStore()
      const responseCode = String(response.data.code)

      //
      function handleLogout() {
        authStore.resetStore()
      }

      function logoutAndCleanup() {
        handleLogout()
        window.removeEventListener('beforeunload', handleLogout)

        request.state.errMsgStack = request.state.errMsgStack.filter(msg => msg !== response.data.msg)
      }

      // 当后端响应状态码在 logoutCodes 中时，表示用户将被登出并重定向到登录页面
      const logoutCodes = import.meta.env.VITE_SERVICE_LOGOUT_CODES?.split(',') || []
      if (logoutCodes.includes(responseCode)) {
        handleLogout()
        return null
      }

      // 当后端响应状态码在 modalLogoutCodes 中时，表示将通过显示模态框来使用户登出
      const modalLogoutCodes = import.meta.env.VITE_SERVICE_MODAL_LOGOUT_CODES?.split(',') || []
      if (modalLogoutCodes.includes(responseCode) && !request.state.errMsgStack?.includes(response.data.msg)) {
        request.state.errMsgStack = [...(request.state.errMsgStack || []), response.data.msg]

        // 防止用户刷新页面
        window.addEventListener('beforeunload', handleLogout)

        window.$dialog?.error({
          title: $t('common.error'),
          content: response.data.msg,
          positiveText: $t('common.confirm'),
          maskClosable: false,
          closeOnEsc: false,
          onPositiveClick() {
            logoutAndCleanup()
          },
          onClose() {
            logoutAndCleanup()
          },
        })

        return null
      }

      // 当后端响应状态码在 expiredTokenCodes 中时，表示 token 已过期，需要刷新 token
      // refreshToken 接口不能返回 expiredTokenCodes 中的错误码，否则会形成死循环，应该返回 logoutCodes 或 modalLogoutCodes
      const expiredTokenCodes = import.meta.env.VITE_SERVICE_EXPIRED_TOKEN_CODES?.split(',') || []
      if (expiredTokenCodes.includes(responseCode)) {
        const success = await handleExpiredRequest(request.state)
        if (success) {
          const Authorization = getAuthorization()
          Object.assign(response.config.headers, { Authorization })

          return instance.request(response.config) as Promise<AxiosResponse>
        }
      }

      return null
    },
    onError(error) {
      // 当请求失败时，可以显示错误信息

      let message = error.message
      let backendErrorCode = ''

      // 获取后端错误信息和状态码
      if (error.code === BACKEND_ERROR_CODE) {
        message = error.response?.data?.msg || message
        backendErrorCode = String(error.response?.data?.code || '')
      }

      // 错误信息已在模态框中显示
      const modalLogoutCodes = import.meta.env.VITE_SERVICE_MODAL_LOGOUT_CODES?.split(',') || []
      if (modalLogoutCodes.includes(backendErrorCode)) {
        return
      }

      // 当 token 过期时，刷新 token 并重试请求，因此不需要显示错误信息
      const expiredTokenCodes = import.meta.env.VITE_SERVICE_EXPIRED_TOKEN_CODES?.split(',') || []
      if (expiredTokenCodes.includes(backendErrorCode)) {
        return
      }

      showErrorMsg(request.state, message)
    },
  },
)

/**
 * 演示请求
 */
export const demoRequest = createRequest(
  {
    baseURL: otherBaseURL.demo,
  },
  /**
   * 演示请求响应数据转换
   */
  {
    // 响应数据转换
    transform(response: AxiosResponse<App.Service.DemoResponse>) {
      return response.data.result
    },
    // 请求配置转换
    async onRequest(config) {
      const { headers } = config

      // 设置 token
      const token = localStg.get('token')
      const Authorization = token ? `Bearer ${token}` : null
      Object.assign(headers, { Authorization })

      return config
    },
    // 响应状态判断
    isBackendSuccess(response) {
      // 当后端响应状态码为 "200" 时，表示请求成功
      // 你可以自行更改此逻辑
      return response.data.status === '200'
    },
    async onBackendFail(_response) {
      // 当后端响应状态码不是 "200" 时，表示请求失败
      // 例如：token 过期，刷新 token 并重试请求
    },
    onError(error) {
      // 当请求失败时，可以显示错误信息

      let message = error.message

      // 显示后端错误信息
      if (error.code === BACKEND_ERROR_CODE) {
        message = error.response?.data?.message || message
      }

      window.$message?.error(message)
    },
  },
)
